#! /usr/bin/perl

my $maxUser = 1000;

my $ldifRoot = <<EOR;
# Organization for iiit
dn: dc=iiit,dc=de
objectClass: dcObject
objectClass: organization
dc: iiit
o: iiit
description: iiit

# Organizational Role for Directory Manager
dn: cn=Manager,dc=iiit,dc=de
objectClass: organizationalRole
cn: Manager
description: Directory Manager

# Organizational Role for Replication Manager
dn: cn=Replicator,dc=iiit,dc=de
objectClass: organizationalRole
cn: Replicator
description: Replication Manager

dn: ou=person,dc=iiit,dc=de
ou: person
objectClass: organizationalUnit

dn: ou=group,dc=iiit,dc=de
ou: group
objectClass: organizationalUnit

dn: ou=formula,dc=iiit,dc=de
ou: formula
objectClass: organizationalUnit

EOR
;

open OUT, "> root.ldif";
print OUT $ldifRoot;
close OUT;

my $chars = "abcdefghijklmnopqrstuvwxyz";
#my $chars = "ab";

my $iMax = length($chars);

for (my $i = 0; $i < $iMax; $i++)
{
    my $char = substr($chars, $i, 1);
#    print "# Char = <$char>\n";

    open OUT, "> p_$char.ldif";

    for (my $u = 1; $u <= $maxUser; $u++)
    {
	my $user = sprintf("$char%04d", $u);
#	print "$user\n";

	my $uid = $i * $maxUser + $u;

	my $ldifUser = <<EOU;
dn: cn=$user,ou=person,dc=iiit,dc=de
cn: $user
uid: $user
objectclass: iiitPerson
sn: $user

EOU
;
	print OUT $ldifUser;

    }

    close OUT;
}

for (my $i = 0; $i < $iMax; $i++)
{
    my $char = substr($chars, $i, 1);
#    print "# Char = <$char>\n";

    open OUT, "> g_$char.ldif";

    print OUT "dn: cn=$char,ou=group,dc=iiit,dc=de\n";
    print OUT "cn: $char\n";
    print OUT "objectClass: iiitGroup\n";
    
    for (my $u = 1; $u <= $maxUser; $u++)
    {
	printf OUT 
	    "memberUid: $char%04d\n", $u;
    }

    print OUT "\n";

    my $gMax = $maxUser / 10;
    for (my $g = 1; $g <= $gMax; $g++)
    {
	my $group = sprintf("$char%03d", $g);

	print OUT "dn: cn=$group,ou=group,dc=iiit,dc=de\n";
	print OUT "cn: $group\n";
	print OUT "objectClass: iiitGroup\n";

	my $uMin = ($g - 1) * 10 + 1;
	my $uMax = $g * 10;

	for ($u = $uMin; $u <= $uMax; $u++)
	{
	    printf OUT 
		"memberUid: $char%04d\n", $u;
	}

	print OUT "\n";
    }

    my $gMax = $maxUser / 100;
    for (my $g = 1; $g <= $gMax; $g++)
    {
	my $group = sprintf("$char%02d", $g);

	print OUT "dn: cn=$group,ou=group,dc=iiit,dc=de\n";
	print OUT "cn: $group\n";
	print OUT "objectClass: iiitGroup\n";

	my $uMin = ($g - 1) * 100 + 1;
	my $uMax = $g * 100;

	for ($u = $uMin; $u <= $uMax; $u++)
	{
	    printf OUT 
		"memberUid: $char%04d\n", $u;
	}

	print OUT "\n";
    }

    close OUT;
}
